/* Generated by Together */

#ifndef AUDIOMIXER_H
#define AUDIOMIXER_H
#include <cc++/thread.h>
#include <vector>

#include "InternalBuffer.h"
#include "OutputStream.h"

using namespace std;
/** @interface */
//! Audio mixer interface
/*!
 * Abstract class acting as an interface for multiple type of audio mixers. This class also acts as a thread once started.
 */
class AudioMixer : public ost::Thread
{
public:
	
    AudioMixer();
    ~AudioMixer();
    
    //! Thread main method
	/*!
	 * Actually does the work in the thread. This method must be implemented in the child class.
	 */
    virtual void run() =0;

protected:
	
	//! Output buffer(s) for the mixed data
	/*!
	 * See OutputStream
	 */
    vector<OutputStream*> audioOutput;
    
    //! Input buffer(s) for the data
    /*!
     * See InternalBuffer
     */
    vector<InternalBuffer*> audioBuffer;
};
#endif //AUDIOMIXER_H
