/* Generated by Together */

#ifndef AUDIOMIXER2CHANNELS_H
#define AUDIOMIXER2CHANNELS_H

#include "AudioMixer.h"
#include "InternalBuffer.h"
#include "OutputStream.h"

//! 2 Channel audio mixer implementation
/*!
 * This class implements a mixer that takes in 2 audio sources and outputs only one.
 */
class AudioMixer2Channels : public AudioMixer {
public:

	//! Contructor
	/*! 
	 * Assigns the input and output buffers
	 * 
	 * \param input1 an input buffer see InternalBuffer
	 * \param input2 an input buffer see InternalBuffer
	 * \param output an output buffer see OutputStream
	 */
    AudioMixer2Channels(InternalBuffer* input1,  InternalBuffer* input2, OutputStream* output);


    //! Destructor
    /*!
     * Terminates the thread, you can also call the terminate method explicitly
     */
    ~AudioMixer2Channels();

	//! Thread main method
	/*!
	 * Actually does the work in the thread. It mixes the 2 inputs into one output.
	 */
    virtual void run();

private:
	
	//! Default Constructor
	/*!
	 * Implemented as private to prevent declaration without the proper buffers
	 */	
    AudioMixer2Channels();  
    
};
#endif //AUDIOMIXER2CHANNELS_H
