/* Generated by Together */

#ifndef AUDIOOUPUT_H
#define AUDIOOUPUT_H

#include "OutputStream.h"

//! Audio Ouput Buffer
/*!
 * This class acts as an Audio output buffer. It implements the OutputStream interface
 */
class AudioOuput : public OutputStream {
public:

	//! Default constructor
	/*!
	 * Initialises the internal buffer
	 */
    AudioOuput();

    //! Destructor
    /*!
     * Cleanly diposes of the buffer
     */
    ~AudioOuput();

    //! Method to get the data contained by the buffer
    /*!
     * \param data a pointer to the where the data will be put
     * \return the size of the buffer
     */
    virtual int fetchData(int16 *data);

    //! Method to change the data contained in the buffer
    /*!
     * \param data a pointer to the data to copy
     * \param size th size of the buffer
     */ 
    virtual void putData(int16 * data, int size);

protected:
	
	//! Data Buffer for the audio data
    int16* buffer;
    
private:
	
	//! Method to change the data in the buffer
	/*!
	 * This method is implemented as private and \b should \b not \b be \b used in AudioOutput. This method is inherited from OutputStream. putData(int16 * data, int size) instead. 
	 */
    virtual void putData(char * data, int size) __attribute__ ((deprecated));
    
    //! Method to get the data in the buffer
	/*!
	 * This method is implemented as private and \b should \b not \b be \b used in AudioOutput. This method is inherited from OutputStream. Use fetchData(int16 *data) instead. 
	 */
    virtual int fetchData(char* data) __attribute__ ((deprecated));

};
#endif //AUDIOOUPUT_H
