/* Generated by Together */

#ifndef INPUTSTREAMS_H
#define INPUTSTREAMS_H

#include "VideoInput.h"
#include "AudioInput.h"

//! Video and audio streams container
/*!
 * This class acts as a container to link the audio feed to the wright video feed.
 */
class InputStreams {
public:

	//! Constructor
	/*!
	 * Creates the container
	 * 
	 * \param videoData a pointer to an VideoInput
	 * \param audioData a pointer to an AudioInput
	 */
    InputStreams(VideoInput* videoData, AudioInput* audioData);
    
    //! Descructors
    /*!
     * The destrcutor dos not destroy the input pointers
     */
    ~InputStreams();
   
    //! Access the video stream
    /*!
     * \return the video stream
     */
    const VideoInput* fetchVideoStream() const;

    //! Access the audio stream
    /*!
     * \return the audio stream
     */
    const AudioInput* fetchAudioStream() const;

private:
	
	//! Default constructor
	/*!
	 * Implemented as privte to prevent a declaration with no streams
	 */
	InputStreams();
	
	//! VideoInput stream pointer
    VideoInput* videoInput;
    
    //! AudioInput stream pointer
    AudioInput* audioInput;
};
#endif //INPUTSTREAMS_H
