/* Generated by Together */

#ifndef INTERNALBUFFER_H
#define INTERNALBUFFER_H

#include <semaphore.h>

//! Internal data sharing class
/*!
 * Acts as an Internal buffer that can be accessed from multiple source.
 */
class InternalBuffer {
public:

	//! Default constructor
	/*!
	 * Initiates the internal buffer
	 */
    InternalBuffer();

    //! Destructor
    /*!
     * Disposes cleanly of the buffer
     */
    ~InternalBuffer();

    //! Changes the data in the buffer
    /*!
     * \param data a pointer to the data to put in the buffer
     * \param size the size of the data
     * \return the success of the operation
     */
    bool putData(char * data, int size);

    //! Gets the data contained in the buffer
    /*!
     * \param data a pointer to put the data
     * \return the size of the data
     */
    int fetchData(char * data);

    //! Intializes the buffer
    void Init();

private:
	
	//! Internal buffer
    char * data;
    
    //! Size of the current buffer
    int size;
    
    //! Semaphore to protect from multiple simultaneous access
    sem_t semaphore;
    
};
#endif //INTERNALBUFFER_H
