/* Generated by Together */

#ifndef LOCALVIDEOOUPUT_H
#define LOCALVIDEOOUPUT_H

#include "../memmanager/MemManager.h"
#include "VideoOutput.h"

//! Local video ouput
/*!
 * This class overloads the class VideoOuput to send the ouput directly to the MemManager and eventualy the GUI . This class is bound to change in a short future.
 */
class LocalVideoOuput : public VideoOutput {
public:

	//! Constructor
	/*!
	 * Initalizes the MemManager
	 */
    LocalVideoOuput();

    //! Destructor
    /*! Closes the MemManager
     */
    virtual ~LocalVideoOuput();

    //! Changes the data in the buffer
    /*!
     * Writes the data to the audio device
     * \param data pointer to the new data
     * \param size the size of data
     */
    virtual void putData(char * data, int size);
    
private:
	
	//! Gets the data in the buffer
    /*!
     * This method is not used in this class
     */
    virtual int fetchData(char* data);
    
    //! Shared memory manager
    MemManager* manager;
    
};
#endif //LOCALVIDEOOUPUT_H
