/* Generated by Together */

#ifndef OUTPUTSTREAM_H
#define OUTPUTSTREAM_H

#include <semaphore.h>

//#include "../global.h"
#include <cc++/config.h>

/** @interface */
//! Interface for the output buffers.
/*
 * Supplies all that is needed to use the ouput buffers.
 */
class OutputStream {
public:

	//! Method to get the data in the buffer
	/*!
	 * Must be implemented in child class. This version is for the video buffer.
	 * 
	 * \param data a pointer to where the data is to be copied
	 * \return the size of data
	 */
    virtual int fetchData(char* data) =0;

	//! Method to get the data in the buffer
	/*!
	 * Must be implemented in child class. This version is for the audio buffer.
	 * 
	 * \param data a pointer to where the data is to be copied
	 * \return the size of data
	 */
    virtual int fetchData(int16* data) =0;

    //! Method to change the data in the buffer
	/*!
	 * Must be implemented in child class. This version is for the video buffer.
	 * 
	 * \param data a pointer to the new data
	 * \param size the size of data
	 */
    virtual void putData(char * data, int size) =0;

    //! Method to change the data in the buffer
	/*!
	 * Must be implemented in child class. This version is for the audio buffer.
	 * 
	 * \param data a pointer to the new data
	 * \param size the size of data
	 */
    virtual void putData(int16 * data, int size) =0;

protected:
	
	//! The size of the current buffer.
    int size;
    
    //! The semaphores that protects the buffer from multiple simultanious access.
    sem_t semaphore;
};
#endif //OUTPUTSTREAM_H
