/* Generated by Together */

#ifndef STRAIGHTTHROUGH_VT_H
#define STRAIGHTTHROUGH_VT_H
#include "VideoMixer.h"

//! Straight Through video mixer
/*!
 * Used when only one input is specifed to the mixer
 */
class StraightThrough_VT : public VideoMixer {
public:

	//! Constructor
	/*!
	 * Initalizes the video mixer with the proper information
	 * 
	 * \param video a pointer to an InternalBuffer acting as input
	 * \param output a pointer to an OutputStream
	 * \param infos a pointer to the CodecInfo
	 */
    StraightThrough_VT(InternalBuffer* video,  OutputStream* output, CodecInfo* infos);

    //! Destructor
    /*!
     * Terminates the thread, you can also call the terminate method explicitly
     */
    ~StraightThrough_VT();

    //! Thread main method
	/*!
	 * Actually does the work in the thread. It essentially copies the input to the ouput.
	 */
    virtual void run();

    //! Pauses the work done by the run method
    virtual void pause();

    //! Resumes the work done by the run method
    /*!
     * Normally used after a pause.
     */
    virtual void restart();


private:
	
	//! Default Constructor
	/*!
	 * Implemented as private to prevent declaration without the proper buffers
	 */
    StraightThrough_VT();
};
#endif //STRAIGHTTHROUGH_VT_H
