/* Generated by Together */

#ifndef SYNCHMANAGER_H
#define SYNCHMANAGER_H

#include <cc++/thread.h> 
#include "InternalBuffer.h"
#include "InputStreams.h"

/** @interface */
//! Synchronization manager interface
/*!
 * Supplies all the methods and attributes needed for a synchmanager
 */
class SynchManager : public ost::Thread {
public:

    //! Thread main method
	/*!
	 * Actually does the work in the thread. Must be implemeted by the child class.
	 */
    virtual void run() = 0;

protected:
	
	//! The inputs to the synchronization manager
    InputStreams* input;
    
    //! The InternalBuffer corresponding to the video ouput of this sychmanager
    InternalBuffer* videoBuffer;
    
    //! The InternalBuffer corresponding to the audio ouput of this sychmanager
    InternalBuffer* audioBuffer;
};
#endif //SYNCHMANAGER_H
