/* Generated by Together */

#ifndef VIDEOMIXER_H
#define VIDEOMIXER_H

#include "InternalBuffer.h"
#include "OutputStream.h"
#include <cc++/thread.h> 

//TODO à enlever et corriger
class CodecInfo{
public:
	int i;
};

//! Video mixer interface
/*!
 * Abstract class acting as an interface for multiple type of video mixers. This class also acts as a thread once started.
 */
class VideoMixer : public ost::Thread {
public:

	//! Thread main method
	/*!
	 * Actually does the work in the thread. This method must be implemented in the child class.
	 */
    virtual void run() = 0;

    //! Method tu set the codec information
    /*!
     * \param infos a pointer to a CodecInfo object
     */
    virtual void setCodecInfo(CodecInfo* infos);

    //! Pauses the work done by the run method
    /*!
     * Must be implemented by the child class
     */
    virtual void pause() = 0;

    //! Resumes the work done by the run method
	/*!
	 * Normally used after a pause. Must be implemented by the child class.
	 */
    virtual void restart() = 0;

protected:
    
	//! Resets the buffer
	/*!
	 * Sets th� buffer to 0 (black background)
	 */
    virtual void resetBuffer();
    
    //! Initiates the buffer
    virtual void initBuffer();
    
    //! Internal Buffer
    char * buffer;
    
    //! Current codec information for ouput format needed
    CodecInfo* infos;
    
    //! Input video buffer
    InternalBuffer* videoBuffer;
    
    //! Output buffer
    OutputStream* videoOuput;

};
#endif //VIDEOMIXER_H
