/* Generated by Together */

#ifndef VIDEOMIXER2CHANNELS_H
#define VIDEOMIXER2CHANNELS_H
#include "VideoMixer.h"

//! 2 Channel video mixer implementation
/*!
 * This class implement a mixer that takes in 2 video sources and outputs only one.
 */
class VideoMixer2Channels : public VideoMixer {
public:

	//! Contructor
	/*! 
	 * Assigns the input and output buffers
	 * 
	 * \param video1 an input buffer see InternalBuffer
	 * \param video2 an input buffer see InternalBuffer
	 * \param output an output buffer see OutputStream
	 * \param infos a pointer to a CodecInfo object
	 */
    VideoMixer2Channels(InternalBuffer* video1, InternalBuffer* video2, OutputStream* output, CodecInfo* infos);

    //! Destructor
    /*!
     * Terminates the thread, you can also call the terminate method explicitly
     */
    ~VideoMixer2Channels();

    //! Thread main method
	/*!
	 * Actually does the work in the thread. It mixes the 2 inputs into one output.
	 */
    virtual void run();

    //! Pauses the work done by the run method
    virtual void pause();

    //! Resumes the work done by the run method
    /*!
     * Normally used after a pause.
     */
    virtual void restart();

private:
	
	//! Default Constructor
	/*!
	 * Implemented as private to prevent declaration without the proper buffers
	 */
    VideoMixer2Channels();
    
};
#endif //VIDEOMIXER2CHANNELS_H
