/* Generated by Together */

#ifndef BRIGHTNESS_H
#define BRIGHTNESS_H
#include "Command.h"

//! Brightness
/*!
 * This class is used to set and get the brightness of the video device
 */ 
class Brightness : public Command {
public:

    //! Constructor
    Brightness();


    //! Destructor
    ~Brightness();


    //! Method to increase the value of the brightness
    /*!
     * \param value that will be added (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool increase(int value);


    //! Method to decrease the value of the brightness
    /*!
     * \param value that will be subtracted (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool decrease(int value);


    //! Method to set the brightness to an exact value 
    /*!
     * \param value that will be added (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool setTo(int value);


    //! Method to reset the brightness to its initial value
    /*!
     * \return a bool representing the success of the operation
     */
    virtual bool reset();


    //! Method to get the brightness value
    /*!
     * \return a string representing the value of the brightness
     */
    char* GetBrightness();
};
#endif //BRIGHTNESS_H

