/* Generated by Together */

#ifndef CAPTURE_H
#define CAPTURE_H

#include <vector>

#include "CaptureMode.h"
#include "Command.h"

using namespace std;
//! Capture
/*!
 * This class is used to get a capture from the video device
 */ 
class Capture : public Command {
public:

    //! Constructor
    Capture();

    //! Destructor
    ~Capture();


    //! Method to switch to the next CaptureMode in the vector
    /*!
     * \return a bool representing the success of the operation
     */
    bool nextCaptureMode();


    //! Method to force the class to use a specific CaptureMode in the vector
    /*!
     * \param captModePos the position of the CaptureMode in the vector
     * \return a bool representing the success of the operation
     */
    bool forceCaptureMode(int captModePos);


    //! Method to create and initialise the captureModes vector  
    /*!
     * Create the captureMode objects and then create the vector
     */
    void createCaptureModesVector();


    //! Method to capture from the video source
    /*!
     * \return a pointer to the captured data
     */
    char* GetCapture();

private:

    //! This method is not applicable to this class
    /*!
     * It is declared as a void methode because it's an abstract methode in the parent class
     */
    virtual bool setTo(int value);

    //! This method is not applicable to this class
    /*!
     * It is declared as a void methode because it's an abstract methode in the parent class
     */
    virtual bool reset();

    //! This method is not applicable to this class
    /*!
     * It is declared as a void methode because it's an abstract methode in the parent class
     */
    virtual bool decrease(int value);

    //! This method is not applicable to this class
    /*!
     * It is declared as a void methode because it's an abstract methode in the parent class
     */
    virtual bool increase(int value);

    //! The position of the CaptureMode to use in the CaptrueMode vector
    int currentCaptureMode;

    /**
     * @supplierCardinality 1..* 
     */
    //! Vector of pointers to the CaptureModes to use
    vector<CaptureMode*> captureModesVector;

};
#endif //CAPTURE_H

