/* Generated by Together */

#ifndef COLOUR_H
#define COLOUR_H
#include "Command.h"

//! Luminosity
/*!
 * This class is used to set and get the colour value of the video device
 */ 
class Colour : public Command {
public:

    //! Constructor
    Colour();

    //! Destructor
    ~Colour();

    //! Method to increase the value of the colour
    /*!
     * \param value that will be added (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool increase(int value);


    //! Method to decrease the value of the colour
    /*!
     * \param value that will be subtracted (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool decrease(int value);


    //! Method to set the colour to an exact value
    /*!
     * \param value that will be added (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool setTo(int value);


    //! Method to reset the colour to its initial value
    /*!
     * \return a bool representing the success of the operation
     */
    virtual bool reset();


    //! Method to get the colour value
    /*!
     * \return a string representing the value of the colour
     */
    char* GetColour();
};
#endif //COLOUR_H
