/* Generated by Together */

#ifndef CONTRAST_H
#define CONTRAST_H
#include "Command.h"
#include <string>

using namespace std;

//! Contrast
/*!
 * This class is used to set and get the contrast value of the video device
 */ 
class Contrast : public Command {
public:

    //! Constructor
    Contrast();


    //! Destructor
    ~Contrast();


    //! Method to increase the value of the contrast
    /*!
     * \param value that will be added (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool increase(int value);


    //! Method to decrease the value of the contrast
    /*!
     * \param value that will be subtracted (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool decrease(int value);


    //! Method to set the contrast to an exact value 
    /*!
     * \param value that will be added (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool setTo(int value);


    //! Method to reset the contrast to its initial value
    /*!
     * \return a bool representing the success of the operation
     */
    virtual bool reset();


    //! Method to get the contrast value
    /*!
     * \return a string representing the value of the contrast
     */
    char* GetContrast();
};
#endif //CONTRAST_H
