/* Generated by Together */

#ifndef RESOLUTION_H
#define RESOLUTION_H
#include "Command.h"
#include <string>

using namespace std;

//! Resolution
/*!
 * This class is used to set and get the resolution of the video device
 */ 
class Resolution : public Command {
public:

    //! Constructor
    Resolution();


    //! Destructor
    ~Resolution();

    //! Method to get the resolution value
    /*!
     * \return a string representing the value of the resolution (i.e. 320X180)
     */
    char* GetResolution(); 
        
    
    //! Method to set the resolution to an exact value 
    /*!
     * \param value that will be added (step value)
     * \return a bool representing the success of the operation
     */
    virtual bool setTo(int valueX, int valueY);


    //! Method to reset the resolution to its initial value
    /*!
     * \return a bool representing the success of the operation
     */
    virtual bool reset();
           

private:

    //! This method is not applicable to this class
    /*!
     * It is declared as a void methode because it's an abstract methode in the parent class
     */
    virtual bool increase(int value);


    //! This method is not applicable to this class
    /*!
     * It is declared as a void methode because it's an abstract methode in the parent class
     */
    virtual bool decrease(int value);
        
};
#endif //RESOLUTION_H
